% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cache-helpers.R
\name{.checkCacheRepo}
\alias{.checkCacheRepo}
\alias{.checkCacheRepo,ANY-method}
\title{Check for cache repository info in ...}
\usage{
.checkCacheRepo(
  object,
  create = FALSE,
  verbose = getOption("reproducible.verbose", 1)
)

\S4method{.checkCacheRepo}{ANY}(
  object,
  create = FALSE,
  verbose = getOption("reproducible.verbose", 1)
)
}
\arguments{
\item{object}{An R object}

\item{create}{Logical. If TRUE, then it will create the path for cache.}

\item{verbose}{Numeric, -1 silent (where possible), 0 being very quiet,
1 showing more messaging, 2 being more messaging, etc.
Default is 1. Above 3 will output much more information about the internals of
Caching, which may help diagnose Caching challenges. Can set globally with an
option, e.g., \code{options('reproducible.verbose' = 0) to reduce to minimal}}
}
\value{
A character string with a path to a cache repository.
}
\description{
This is a generic definition that can be extended according to class.
Normally, \code{checkPath} can be called directly, but does not have class-specific methods.
}
\examples{
a <- "test"
.checkCacheRepo(a) # no cache repository supplied

}
\author{
Eliot McIntire
}
